
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C247EC  ; location in v1.0 or v1.1
;org $C247D5  ; location in SFC version
exit_ending:
C247EC:	RTS

end_battle:
C247ED:	LDA $3EE0  ; are we in final battle?
C247F0:	BEQ normal_battle  ; branch if so
	JSR return_wound  ; return Wound status to midair Wounded Jumpers
REPLACE1:
C247F5:	LDX $3A6E  ; combat ending
;C247F5:	LDA $3A6E  ; one instruction replaces three
;	BEQ normal_battle
;	TAX
C247F8: JMP (battle_end_table,X)

warp_escape:  ; comment out label if reversing
	LDA #$FF
	STA $0205
	LDA #$10
	BRA mark_ending

normal_battle:
C24804:	LDA $1DD1
C24807:	AND #$20
REPLACE2:
C24809:	BNE mark_ending
;C24809:	BEQ check_script_f5
;	TSB $3EBC
;	BRA skip_far_out

check_script_f5:
C2480B:	LDA $3A95  ; did monster script F5 nn 04 happen?
C2480E:	BNE exit_ending  ; if so, exit
C24810:	LDA $3A74  ; list of living, present party members
C24813:	BNE check_monsters  ; branch if any
C24815:	LDA $3A8A  ; list of Engulfed party members
;REMOVED1:	BEQ check_escapers
C24818:	CMP $3A8D  ; compare to starting lineup
C2481B:	BNE check_escapers  ; branch if any differences
C2481D:	LDA #$80

mark_ending:
C2481F:	TSB $3EBC

skip_far_out:
fb_02:  ; comment out label if reversing
	JSR close_battle
REPLACE3:
C24825:	BRA update_party  ; one for one replacement
;C24825:	BRA fb_02

check_escapers:
C24827:	LDA $3A39
C2482A:	BNE warp_escape
C2482C:	LDA $3A97
C2482F:	BNE process_loss  ; branch if in Colosseum
C24831:	LDA #$29
	BRA process_loss

banon_fell:  ; comment out label if reversing
	LDA #$36

process_loss:
C24837:	JSR $5FCA  ; v1.0 or v1.1
;C24837:	JSR $5FBB  ; v1.0 or v1.1 w/Gogo & Cursed Shield patch
;C24837:	JSR $5FB2  ; SFC only
;C24837:	JSR $5FA3  ; SFC w/Gogo & Cursed Shield patch
C2483A:	BRA update_party

check_monsters:
C2483C:	LDA $3A77  ; monsters left in combat
C2483F:	BNE exit_ending  ; exit if any
C24841:	LDA $3EE0  ; final battle?
C24844:	BNE check_gau  ; if not, skip JSR
C24846:	JSR $4A76  ; v1.0 or v1.1
;C24846:	JSR $4A5E  ; SFC only

check_gau:
C24849:	LDX $300B  ; Gau's place in party
C2484C:	BMI check_shadow  ; branch if null
C2484E:	LDA #$01
C24850:	TRB $11E4  ; mark as unable to return
C24853:	BEQ check_shadow  ; branch if already marked
C24855:	JSR $4B5A  ; v1.0 or v1.1
;C24855:	JSR $4B42  ; SFC only
C24858:	CMP #$A0
C2485A:	BCS check_shadow  ; 37.5% chance of branch
C2485C:	LDA $3EBD
REPLACE4:
C2485F:	AND #$02  ; three instructions...
C24861:	ORA $3A76
C24864:	LSR A
;C2485F:	BIT #$02  ; ...replace four
;C24861:	BMI gau_return
;C24863:	LDA $3A76
;C24864:	CMP #$02
C24865:	BNE gau_return

check_shadow:
C24867:	LDX $3003  ; Shadow's place in party
C2486A:	BMI spoils  ; branch if null
;REMOVED2:
;	JSR $4B5A  ; v1.0 or v1.1
;	JSR $4B42  ; SFC only
;	CMP #$10
;	BCS spoils
C2486C:	LDA $201F  ; encounter type
C2486F:	BNE spoils  ; branch if not a frontal attack
C24871:	LDA $3A76
REPLACE5:
C24874:	LSR A  ; two for two
C24875:	BEQ spoils  ; branch if 1 or less characters in party
;C24874:	CMP #$02
;C24875:	BCC spoils
C24877:	LDA $3EE4,X
C2487A:	BIT #$C2  ; is Shadow Wounded, Petrified or a Zombie?
C2487C:	BNE spoils  ; branch if so
	JSR $4B5A  ; v1.0 or v1.1
;	JSR $4B42  ; SFC only
	CMP #$10  ; 1-in-16 chance of leaving
	BCS spoils
C24885:	LDA #$08
C24887:	BIT $3EBD  ; is Shadow allowed to randomly leave?
C2488A:	BNE spoils  ; branch if not
C2488C:	BIT $1EDE  ; is Shadow enlisted?
C2488F:	BNE shadow_leaves  ; if so, make him leave

spoils:
C24891:	JSR $5D57  ; v1.0 or v1.1
;C24891:	JSR $5D3F  ; SFC only

update_party:
C24894:	JSR $4936  ; v1.0 or v1.1
;C24894:	JSR $491E  ; SFC only
C24897:	PLA  ; remove RTS pointer
C24898:	PLA
C24899:	JMP $00C5

;REMOVED3:
;warp_escape:  ; uncomment label if reversing
;	LDA #$FF
;	STA $0205
;	LDA #$10
;	TSB $3EBC
;
;fb_02:  ; uncomment label if reversing
;	JSR close_battle
;	BRA update_party

shadow_leaves:
C2489C:	TRB $1EDE  ; un-enlist Shadow
C2489F:	JSR $47E3  ; v1.0 or v1.1
;C2489F:	JSR $47CB  ; SFC only
C248A2:	REP #$10  ; 16-bit X & Y
C248A4:	LDY $3010,X  ; character info offset
C248A7:	LDA #$FF
C248A9:	STA $161E,Y  ; remove equipped Esper
C248AC:	SEP #$10  ; 8-bit X & Y
REPLACE6:
C248AE:	DEC A  ; one for one
;C248AE:	LDA #$FE
C248AF:	JSR $0792  ; v1.0 or v1.1
;C248AF:	JSR $078A  ; SFC only
C248B2:	LDA #$02
C248B4:	TSB $2F49  ; disable victory dance
C248B7:	LDX #$0B  ; prepare "Shadow leaves" battle event

queue_battle_event:
C248B9:	PLA  ; remove RTS pointer
C248BA:	PLA
C248BB:	LDA #$23  ; queue Battle Event
C248BD:	JSR $4E91  ; v1.0 or v1.1
;C248BD:	JSR $4E79  ; SFC only
C248C0:	JMP $0019

gau_return:
C248C3:	LDA $3018,X
REPLACE7:
C248C6:	JSR enemy_gau  ; JSR replaces two TSBs
;C248C6:	TSB $2F4E
;C248C7:	TSB $3A40
C248C9:	LDA #$04
C248CB:	TSB $3A46
C248CE:	JSR $4926  ; v1.0 or v1.1
;C248CE:	JSR $490E  ; SFC only
C248D1:	LDX #$1B  ; prepare "Gau returns from Leap" battle event
C248D3:	BRA queue_battle_event

gau_leaps:
C248D5:	LDX $300B
C248D8:	JSR $47E3  ; v1.0 or v1.1
;C248D8:	JSR $47CB  ; SFC only
C248DB:	LDA #$08
C248DD:	TRB $1EDF  ; un-enlist Gau

fb_09:
C248E0:	JSR $4A07  ; v1.0 or v1.1
;C248E0:	JSR $49EF  ; SFC only
C248E3:	JMP fb_02

;REMOVED4:
;banon_fell:  ; uncomment label if reversing
;	LDA #$36
;	JSR $5FCA  ; v1.0 or v1.1
;	JSR $5FBB  ; v1.0 or v1.1 w/Gogo & Cursed Shield patch
;	JSR $5FB2  ; SFC only
;	JSR $5FA3  ; SFC w/Gogo & Cursed Shield patch
;	BRA update_party
;
;battle_end_table:  ; uncomment label if reversing
;DW warp_escape,gau_leaps,banon_fell,fb_02,fb_09
;DW $4A22  ; v1.0 or v1.1
;DW $4A0A  ; SFC only

return_wound:
	LDX #$06
	
check_member:
	LDA $3BF4,X
	ORA $3BF5,X
	BNE next_member  ; branch if HP not 0
	LDA $3EE4,X
	BIT #$82  ; is party member Wounded or Zombified?
	BNE next_member  ; if neither...
	ORA #$80
	STA $3EE4,X  ; add Wound
	
next_member:
	DEX
	DEX
	BPL check_member  ; loop over entire party
	JMP $4AB9  ; v1.0 or v1.1
;	JMP $4AA1  ; SFC only

close_battle:

org $C25EB6  ; location in v1.0 or v1.1
;org $C25E9E  ; location in SFC version
C25EB6:	JSR learned_spells

org $C260E0  ; location in v1.0 or v1.1
;org $C260C8  ; location in SFC version
C260E0:	BMI inc_hp_mp

org $C260ED  ; location in v1.0 or v1.1
;org $C260D5  ; location in SFC version
C260ED:	BMI restore_x_y
	CMP #$09
	BCS boost_stats  ; branch if boosting Vigor, Speed, Stamina or MagPwr
	CMP #$06
	BEQ double_hp  ; branch if doubling HP boost
	BCS restore_x_y  ; branch if no bonus
	CMP #$03
	BCC get_boost_percent  ; branch if boosting HP
	SBC #$03

get_boost_percent:
	TAX
	LDA bonus_percent_table,X  ; get bonus amount
	PHA  ; preserve it
	TDC
	ROL A
C26107:	ASL A
C26108:	TAX
	PLA  ; restore bonus amount
	XBA  ; move to high byte of A
;REMOVED5:
;	JSR (old_bonus_table,X)
	LDA $FC,X  ; get normal boost
	JSR $4781  ; v1.0 or v1.1
;	JSR $4769  ; SFC only
	XBA  ; boost = normal * bonus / 256
	BNE add_to_hp_mp_boost  ; if zero...
	INC A  ; ...set to one

add_to_hp_mp_boost:
	CLC
	ADC $FC,X  ; add to normal boost
	STA $FC,X
	BCC restore_x_y
	INC $FD,X  ; carry any overflow
	BRA restore_x_y

double_hp:
	TDC
	TAX
	LDA $FC
	BRA add_to_hp_mp_boost

boost_stats:
	DEC A
	LSR A
	PHP
	PHY
	REP #$21
	ADC $01,S
	TAY
	PLA
	PLP
	LDA $1616,Y
	ADC #$01
	CMP #$81
	BCC update_stat
	LDA #$80

update_stat:
	STA $1616,Y

restore_x_y:
C2613E:	PLX
C2613F:	PLY

inc_hp_mp:
C26140:	REP #$21  ; 16-bit A
REPLACE7:
C26142:	PHY  ; five instructions...
C26143:	PHX
C26144:	TXY
C26145:	TDC
C26146:	TAX
;C26142:	LDA $160B,X  ; ...replace nine
;	PHA
;	AND #$C000
;	STA $EE
;	PLA
;	AND #$3FFF
;	ADC $FC
;	CMP #$2710
;	BCC hp9999
C26147:	LDA #$270F
;REMOVED6:
;hp9999:
;	ORA $EE
;	STA $160B,X
	JSR inc_max_value
	INX
	INX
	INY
	INY
	INY
	INY
	LDA #$03E7
	JSR inc_max_value
	PLX
	PLY
	PLP
	RTS

inc_max_value:
C2615D:	CLC
	PHA
REPLACE8:
C2615F:	LDA $160B,Y  ; one for one
;C2615F:	LDA $160F,X
C26162:	PHA
C26163:	AND #$C000
C26166:	STA $EE
C26168:	PLA
C26169:	AND #$3FFF
REPLACE9:
C2616C:	ADC $FC,X  ; two for two
C2616E:	CMP $01,S
;C2616C:	ADC $FE
;C2616E:	CMP #$03E8
C26170:	BCC mp999
REPLACE10:
C26172:	LDA $01,S  ; one for one
;C26172:	LDA #$03E7

mp999:
C26174:	ORA $EE
REPLACE11:
C26176:	STA $160B,Y  ; one for one
;C26176:	STA $160F,X
C26179:	PLP
C2617A:	RTS

learned_spells:
C2617B:	PHY
C2617C:	LDY #$0035

spell_loop:
C2617F:	LDA ($F4),Y
C26181:	CMP #$80
C26183:	BNE next_spell
C26185:	LDA #$FF
C26187:	STA ($F4),Y
C26189:	STY $2F35
C2618C:	LDA #$32
C2618E:	JSR $5FD4  ; v1.0 or v1.1
;C2618E:	JSR $5FC5  ; v1.0 or v1.1 w/Gogo & Cursed Shield patch
;C2618E:	JSR $5FBC  ; SFC only
;C2618E:	JSR $5FAD  ; SFC w/Gogo & Cursed Shield patch

next_spell:
C26191:	DEY
C26192:	BPL spell_loop
C26194:	PLY
C26195:	RTS

;REMOVED7:
;old_bonus_table:
;DW hp_mp_10,hp_mp_30,hp_mp_50
;DW hp_mp_10,hp_mp_30,hp_mp_50
;DW hp_doubled,end_bonus,end_bonus
;DW inc_vigor,inc_vigor
;DW inc_speed,inc_speed
;DW inc_stamina,inc_stamina
;DW inc_magpwr,inc_magpwr
;
;hp_mp_10:
;	LDA #$1A
;	BRA hp_mp_any
;
;hp_mp_30:
;	LDA #$4E
;	BRA hp_mp_any
;
;hp_mp_50:
;	LDA #$80
;
;hp_mp_any:
;	CPX #$0006
;	LDX #$0000
;	BCC hp_mp_chosen
;	INX
;	INX
;
;hp_mp_chosen:
;	XBA
;	LDA $FC,X
;	JSR $4781  ; v1.0 or v1.1
;	JSR $4769  ; SFC only
;	XBA
;	BNE add_it_on
;	INC A
;
;add_it_on:
;	CLC
;	ADC $FC,X
;	STA $FC,X
;	BCC end_bonus
;	INC $FD,X
;
;end_bonus:
;	RTS
;
;inc_magpwr:
;	INY
;
;inc_stamina:
;	INY
;
;inc_speed:
;	INY
;
;inc_vigor:
;	TXA
;	LSR A
;	LSR A
;	TYX
;	LDA $161A,X
;	INC A
;	BCS boosted_stats
;	INC A
;
;boosted_stats:
;	CMP #$81
;	BCC final_update
;	LDA #$80
;
;final_update:
;	STA $161A,X
;	RTS
;
;hp_doubled:
;	TDC
;	TAX
;	LDA $FC
;	BRA add_it_on

bonus_percent_table:
DB $1A,$4D,$80

battle_end_table:  ; comment out label if reversing
DW normal_battle,warp_escape,gau_leaps,banon_fell,fb_02,fb_09
DW $4A22  ; v1.0 or v1.1
;DW $4A0A  ; SFC only

enemy_gau:
	TSB $2F4E  ; mark to enter battle
	TSB $3A40  ; mark as enemy character
	RTS

padbyte $EA : pad $C261B6  ; v1.0 or v1.1
;padbyte $EA : pad $C2619E  ; SFC version