import struct
import sys

def printUsage():
	print('Usage: python headerizer.py [-u] INFILE [OUTFILE|-s]')
	print('\n\t-u\tUnheaderize the patch')
	print('\t-s\tOverwrite INFILE')
	sys.exit(0)

def byteStringToList(str):
	return [str[t:t+1] for t in range(len(str))]

print('Headerizer v1.5 by Leet Sketcher (13375K37CH3R)')
if len(sys.argv) < 2:
	printUsage()
index = 1
offset = 2
if str(sys.argv[1]) == '-u':
	offset = -2
	index = 2
if len(sys.argv) == index:
	printUsage()
inFile = str(sys.argv[index])
if not inFile.lower().endswith(".ips"):
	raise ValueError('The source file must be a .ips file.')
wb = []
with open(inFile, 'rb') as f:
	for x in range(5):
		wb = wb + [f.read(1)]
	while 1:
		
		location = struct.unpack('>H', f.read(2))[0]
		low = f.read(1)
		if location == 0x454f and low == b'F':
			break
		location += offset
		wb = wb + byteStringToList(struct.pack('>H', location))
		wb = wb + [low]
		lng = f.read(2)
		wb = wb + byteStringToList(lng)
		length = struct.unpack('>H', lng)[0]
		if length == 0:
			length += 3
		wb = wb + byteStringToList(f.read(length))
	wb = wb + [b'E', b'O', b'F']
	truncateBytes = f.read(2)
	truncateLow = f.read(1)
	if truncateLow != b'':
		truncateHigh = struct.unpack('>H', truncateBytes)[0]
		truncateHigh += offset
		wb = wb + byteStringToList(struct.pack('>H', truncateHigh))
		wb = wb + [truncateLow]
if len(sys.argv) - index == 1:
	outFile = inFile[0:inFile.rfind(".")]
	if offset < 0:
		outFile += "-N"
	else:
		outFile += "-H"
	outFile += ".ips"
elif str(sys.argv[index + 1]) == "-s":
	outFile = inFile
else:
	outFile = str(sys.argv[index + 1])
if not outFile.lower().endswith(".ips"):
	raise ValueError('The output file must be a .ips file.')
with open(outFile, 'wb') as f:
	for byt in wb:
		f.write(byt)
sys.stdout.write('The patch was successfully ')
if offset < 0:
	sys.stdout.write('un')
sys.stdout.write('headerized.\n')