
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C20D4A  ; location in v1.0 and v1.1
;org $C20D42  ; location in SFC version
add_acc_damage:  ; add value in A to damage value
C20D4A:	CLC  ; clear carry bit for adding purposes

add_with_carry:
C20D4B:	PEA $0000  ; store this 16-bit value on stack; it will be pulled shortly
C20D4E:	BRA add_damage

one_point_five:
C20D50:	LDA $EA  ; load top two bytes of damage
C20D52:	LSR A  ; divide by 2
C20D53:	PHA  ; push to stack for later
C20D54:	LDA $E8  ; load bottom two bytes
C20D56:	ROR  ; divide by 2, carrying least significant bit from $EA

add_damage:
C20D57:	ADC $E8  ; add to bottom two bytes
C20D59:	STA $E8  ; store the result
C20D5B:	PLA  ; now pull previously pushed 16-bit value

add_overflow:
C20D5C:	ADC $EA  ; add to top two bytes
C20D5E:	STA $EA  ; store the result
C20D60:	RTS

damage_part2:
C20D61:	BIT #$0003  ; check if we have two Earrings equipped
C20D64:	BCS atlas  ; if attack if physical and doesn't concern MP, check for Atlas Armlet
C20D66:	BNE two_earrings  ; if double Earrings check failed, check for single Earrings
C20D68:	XBA
C20D69:	LSR A

atlas:
C20D6A:	LSR A
C20D6B:	LDA $E8  ; load damage
C20D6D:	BCC exit  ; if check failed, exit
C20D6F:	LSR A
C20D70:	BRA earrings

two_earrings:
C20D72:	LDA $E8  ; only necessary if we have two Earrings equipped

earrings:
C20D74:	LSR A
C20D75:	JSR add_acc_damage

exit:
C20D78:	LDA $EA
C20D7A:	BEQ real_damage  ; if damage overflowed...
C20D7C:	TDC
C20D7D:	DEC  ; ...then set to 65,535
C20D7E:	BRA finalize

real_damage:
C20D80:	LDA $E8  ; otherwise, take normal amount of damage

finalize:
C20D82:	STA $11B0  ; store damage
C20D85:	PLP
C20D86:	RTS

org $C22B69  ; location in v1.0 and v1.1
;org $C22B64
damage_alg:
C22B69:	LDA $11AF  ; attacker's Level
C22B6C:	STA $E8  ; copy to $E8
C22B6E:	TAY  ; copy to Y
C22B6F:	LDA $11A2  ; check if attack is magical
C22B72:	LSR A
C22B73:	PHP  ; save P for future magic checks
C22B74:	STZ $EB  ; clear $EB
C22B76:	TDC  ; clear 16 bits of A
C22B77:	LDA $11A6  ; battle power if physical, spell power if magical
C22B7A:	REP #$20  ; 16-bit A
C22B7C:	BCC magical  ; if attack is physical...
C22B7E:	CPX #$08  ; ...and attacker is a monster...
C22B80:	BRA quadruple  ; ...or if attack is magical...

magical:
C22B82:	CPY #$01  ; ...and Level is not 0...
C22B84:	TAY  ; store spell power if attack is magical, btw

quadruple:
C22B85:	BCC after_quad
C22B87:	ASL A  ; if checks succeeded, quadruple power
C22B88:	ASL A

after_quad:
C22B89:	PHA  ; push power to stack
C22B8A:	LDA $03,S  ; check again if attack is magical
C22B8C:	LSR A
C22B8D:	TDC  ; if it is, set A to 0
C22B8E:	BCC multiply  ; if not, do the following
C22B90:	LDA $B2
C22B92:	ASL A  ; check if Gauntlet is equipped
C22B93:	ASL A
C22B94:	LDA $01,S  ; load battle power
C22B96: BCS clear_carry  ; if Gauntlet is equipped...
C22B98:	LSR A  ; A = BP / 2
C22B99:	ADC $01,S  ; A = BP * 3 / 2
C22B9B:	LSR A  ; A = BP * 3 / 4
C22B9C:	ADC $01,S  ; A = BP * 7 / 4

clear_carry:
C22B9E:	CLC

multiply:
C22B9F:	SEP #$20  ; set 8-bit A for a while
C22BA1:	ADC $11AE  ; add Vigor if physical, load MagPwr if magical
C22BA4:	XBA
C22BA5:	ADC #$00  ; carry the one
C22BA7:	XBA
C22BA8:	JSR $47B7  ; v1.0 or v1.1 ; 16-bit "Attack" x 8-bit Level
;C22BA8:	JSR $479F  ; SFC version only
C22BAB:	TYA  ; Level if physical, spell power if magical
C22BAC:	JSR $4781  ; v1.0 or v1.1 ; Y x high byte of first multiply
;C22BAC:	JSR $4769  ; SFC version only
C22BAF:	REP #$20  ; 16-bit A
C22BB1:	PHA  ; push result of second multiply
C22BB2:	LDA $E8  ; get low 16 bits of first multiply
C22BB4:	STY $E8  ; Level if physical, spell power if magical
C22BB6:	JSR $47B7  ; v1.0 or v1.1 ; Y x low 16 bits of first multiply
;C22BB6:	JSR $479F  ; SFC version only
C22BB9:	PLA  ; pull result of second multiply
C22BBA:	JSR add_overflow  ; add result of second multiply to $EA
C22BBD:	LDA $03,S  ; load P from earlier
C22BBF:	LSR A  ; check attack type again
C22BC0:	PHP  ; save again
C22BC1:	LDA #$0004  ; divide damage by 32
C22BC4:	BCC divide
C22BC6:	ASL A
C22BC7:	DEC A  ; if attack is physical, divide by 256 instead

divide:
C22BC8:	JSR $0DD1  ; v1.0 or v1.1 ; this function does the division
;C22BC8:	JSR $0DC9  ; SFC version only
C22BCB:	STA $E8
C22BCD:	PLP
C22BCE:	PLA  ; battle power if physical, spell power if magical
C22BCF:	BCC after_genjioff  ; if attack is physical, do the following
C22BD1:	TAY  ; copy battle power to Y
C22BD2:	CPX #$08
C22BD4:	BCS clear_acc  ; don't modify physical damage if entity is a monster
C22BD6:	JSR one_point_five  ; multiply by 1.5
C22BD9:	TYA
C22BDA:	JSR add_acc_damage  ; then add battle power
C22BDD:	LDY $B5  ; check command
C22BDF:	BEQ genjioff  ; if it's not Fight...
C22BE1:	CPY #$06  ; ...or Capture...
C22BE3:	BNE clear_acc  ; ...then skip relic check

genjioff:
C22BE5:	LDA $3C58,X
C22BE8:	LSR A  ; if Offering is equipped...
C22BE9:	BCC genji
C22BEB:	LSR $EA  ; ...then cut damage in half
C22BED:	ROR $E8
C22BEF:	PHA
C22BF0:	TDC
C22BF1:	JSR add_with_carry  ; round up
C22BF4:	PLA

genji:
C22BF5:	BIT #$0008  ; if Genji Glove is equipped...
C22BF8:	BEQ clear_acc
C22BFA:	JSR one_point_five  ; ...then multiply by 1.5
C22BFD:	INC $E8  ; we'll then divide by 2 and round
C22BFF:	BNE after_round  ; if $E8 is 0, that means overflow just happened
C22C01:	INC A

after_round:
C22C02:	LSR A  ; now we'll divide by 2
C22C03:	STA $EA
C22C05:	ROR $E8  ; so damage has now been effectively multiplied by 3/4

clear_acc:
C22C07:	TDC  ; clear A if damage is physical

after_genjioff:
C22C08:	JSR add_acc_damage  ; add spell power to damage if attack is magical
C22C0B:	LDA $11A4
C22C0E:	LSR A  ; check if attack heals
C22C0F:	BCC start_part2
C22C11:	JMP exit  ; if it does, skip Atlas Armlet/Earrings check

start_part2:
C22C14:	LDA $11A2
C22C17:	BMI check_relics  ; carry bit is clear if attack concerns MP...
C22C19:	LSR A  ; ...or is magical

check_relics:
C22C1A:	LDA $3C44,X  ; load current relic effects
C22C1D:	JMP damage_part2
C22C20:	RTS

org $C2322B  ; location in v1.0 and v1.1
;org $C23226  ; location in SFC version
C2322B:	JSR damage_alg

C2322E:	NOP
C2322F:	NOP
C23230:	NOP